/*  File: pl-codetable.c

    This file provides a description of the virtual machine instructions
    and their arguments. It  is  used by  pl-comp.c  to facilitate the
    compiler and decompiler, as well as pl-wic.c to save/reload sequences
    of virtual machine qinstructions.

    Note: this file is generated by ./mkvmi from pl-vmi.c.  DO NOT EDIT    
*/

#include "pl-incl.h"

const code_info codeTable[] = {
  /* {name, ID, #args, argtype} */
  {"d_break", D_BREAK, 0, {0}},
  {"i_nop", I_NOP, 0, {0}},
  {"h_const", H_CONST, 1, {CA1_DATA}},
  {"h_nil", H_NIL, 0, {0}},
  {"h_integer", H_INTEGER, 1, {CA1_INTEGER}},
  {"h_int64", H_INT64, WORDS_PER_INT64, {CA1_INT64}},
  {"h_float", H_FLOAT, WORDS_PER_DOUBLE, {CA1_FLOAT}},
  {"h_mpz", H_MPZ, VM_DYNARGC, {CA1_MPZ}},
  {"h_string", H_STRING, VM_DYNARGC, {CA1_STRING}},
  {"h_void", H_VOID, 0, {0}},
  {"h_var", H_VAR, 1, {CA1_VAR}},
  {"h_firstvar", H_FIRSTVAR, 1, {CA1_VAR}},
  {"h_functor", H_FUNCTOR, 1, {CA1_FUNC}},
  {"h_rfunctor", H_RFUNCTOR, 1, {CA1_FUNC}},
  {"h_list", H_LIST, 0, {0}},
  {"h_rlist", H_RLIST, 0, {0}},
  {"b_const", B_CONST, 1, {CA1_DATA}},
  {"b_nil", B_NIL, 0, {0}},
  {"b_integer", B_INTEGER, 1, {CA1_INTEGER}},
  {"b_int64", B_INT64, WORDS_PER_INT64, {CA1_INT64}},
  {"b_float", B_FLOAT, WORDS_PER_DOUBLE, {CA1_FLOAT}},
  {"b_mpz", B_MPZ, VM_DYNARGC, {CA1_MPZ}},
  {"b_string", B_STRING, VM_DYNARGC, {CA1_STRING}},
  {"b_argvar", B_ARGVAR, 1, {CA1_VAR}},
  {"b_var0", B_VAR0, 0, {0}},
  {"b_var1", B_VAR1, 0, {0}},
  {"b_var2", B_VAR2, 0, {0}},
  {"b_var", B_VAR, 1, {CA1_VAR}},
  {"b_argfirstvar", B_ARGFIRSTVAR, 1, {CA1_VAR}},
  {"b_firstvar", B_FIRSTVAR, 1, {CA1_VAR}},
  {"b_void", B_VOID, 0, {0}},
  {"b_functor", B_FUNCTOR, 1, {CA1_FUNC}},
  {"b_rfunctor", B_RFUNCTOR, 1, {CA1_FUNC}},
  {"b_list", B_LIST, 0, {0}},
  {"b_rlist", B_RLIST, 0, {0}},
  {"i_popf", I_POPF, 0, {0}},
  {"i_enter", I_ENTER, 0, {0}},
  {"i_context", I_CONTEXT, 1, {CA1_MODULE}},
  {"i_call", I_CALL, 1, {CA1_PROC}},
  {"i_depart", I_DEPART, 1, {CA1_PROC}},
  {"i_exit", I_EXIT, 0, {0}},
  {"i_exitfact", I_EXITFACT, 0, {0}},
  {"i_cut", I_CUT, 0, {0}},
  {"c_jmp", C_JMP, 1, {CA1_JUMP}},
  {"c_or", C_OR, 1, {CA1_JUMP}},
  {"c_ifthen", C_IFTHEN, 1, {CA1_VAR}},
  {"c_not", C_NOT, 2, {CA1_VAR, CA1_JUMP}},
  {"c_ifthenelse", C_IFTHENELSE, 2, {CA1_VAR, CA1_JUMP}},
  {"c_var", C_VAR, 1, {CA1_VAR}},
  {"c_lcut", C_LCUT, 1, {CA1_VAR}},
  {"c_cut", C_CUT, 1, {CA1_VAR}},
  {"c_softif", C_SOFTIF, 2, {CA1_VAR, CA1_JUMP}},
  {"c_softcut", C_SOFTCUT, 1, {CA1_VAR}},
  {"c_end", C_END, 0, {0}},
  {"c_fail", C_FAIL, 0, {0}},
  {"i_fail", I_FAIL, 0, {0}},
  {"i_true", I_TRUE, 0, {0}},
  {"a_enter", A_ENTER, 0, {0}},
  {"a_integer", A_INTEGER, 1, {CA1_INTEGER}},
  {"a_int64", A_INT64, WORDS_PER_INT64, {CA1_INT64}},
  {"a_mpz", A_MPZ, VM_DYNARGC, {CA1_MPZ}},
  {"a_double", A_DOUBLE, WORDS_PER_DOUBLE, {CA1_FLOAT}},
  {"a_var", A_VAR, 1, {CA1_VAR}},
  {"a_var0", A_VAR0, 0, {0}},
  {"a_var1", A_VAR1, 0, {0}},
  {"a_var2", A_VAR2, 0, {0}},
  {"a_func0", A_FUNC0, 1, {CA1_AFUNC}},
  {"a_func1", A_FUNC1, 1, {CA1_AFUNC}},
  {"a_func2", A_FUNC2, 1, {CA1_AFUNC}},
  {"a_func", A_FUNC, 2, {CA1_AFUNC, CA1_INTEGER}},
  {"a_lt", A_LT, 0, {0}},
  {"a_le", A_LE, 0, {0}},
  {"a_gt", A_GT, 0, {0}},
  {"a_ge", A_GE, 0, {0}},
  {"a_eq", A_EQ, 0, {0}},
  {"a_ne", A_NE, 0, {0}},
  {"a_is", A_IS, 0, {0}},
  {"i_call_fv0", I_CALL_FV0, 1, {CA1_PROC}},
  {"i_call_fv1", I_CALL_FV1, 2, {CA1_PROC, CA1_VAR}},
  {"i_call_fv2", I_CALL_FV2, 3, {CA1_PROC, CA1_VAR, CA1_VAR}},
  {"i_callcleanup", I_CALLCLEANUP, 0, {0}},
  {"i_exitcleanup", I_EXITCLEANUP, 0, {0}},
  {"i_catch", I_CATCH, 0, {0}},
  {"i_exitcatch", I_EXITCATCH, 0, {0}},
  {"b_throw", B_THROW, 0, {0}},
  {"b_exit", B_EXIT, 0, {0}},
  {"i_cut_block", I_CUT_BLOCK, 0, {0}},
  {"i_usercall0", I_USERCALL0, 0, {0}},
  {"i_usercalln", I_USERCALLN, 1, {CA1_INTEGER}},
  {"i_apply", I_APPLY, 0, {0}},
  { NULL, 0, 0, {0} }
};
